-- Don't change this --
ESX = nil
QBCore = nil

-- You can change this --
if Config.Framework == 'ESX' then
	TriggerEvent('esx:getSharedObject', function(obj) ESX = obj; end)
elseif Config.Framework == 'QB' then
	QBCore = exports["qb-core"]:GetCoreObject()
end

-- WEBHOOKS --

playerReportWebhookLink = '' -- Player Report webhook

bugReportWebhookLink = '' -- Bug Report webhook

questionReportWebhookLink = '' -- Question webhook

adminWebhookLink = '' -- Admin related activities webhook (bring/go to/answer/conclude)

playerWebhookLink = ''-- Player related activities webhook (answer/cancel)

RegisterServerEvent('okokReportsV2:OnPlayerCancel')
AddEventHandler('okokReportsV2:OnPlayerCancel', function(source)
	
end)

RegisterServerEvent('okokReportsV2:OnConcluded')
AddEventHandler('okokReportsV2:OnConcluded', function(source, tagetSource)
	
end)

RegisterServerEvent('okokReportsV2:OnBring')
AddEventHandler('okokReportsV2:OnBring', function(source, tagetSource)
	
end)

RegisterServerEvent('okokReportsV2:OnGoTo')
AddEventHandler('okokReportsV2:OnGoTo', function(source, tagetSource)
	
end)

RegisterServerEvent('okokReportsV2:OnAnswer')
AddEventHandler('okokReportsV2:OnAnswer', function(source, tagetSource) -- tagetSource = nil if it's a player responding
	
end)

RegisterServerEvent('okokReportsV2:OnCreateReport')
AddEventHandler('okokReportsV2:OnCreateReport', function(source)
	
end)

function hasPermission(source)
	local staff = false
	
	if Config.Framework == 'ESX' then
		if Config.UseNewStaffCheckMethod then 
			for k,v in ipairs(Config.AdminGroups) do
				if ESX.HasGroup(source, v) then
					staff = true
					break
				end
			end
		else
			local xPlayer = ESX.GetPlayerFromId(source)
			if xPlayer ~= nil then
				local playerGroup = xPlayer.getGroup()

				for k,v in ipairs(Config.AdminGroups) do
					if playerGroup == v then 
						staff = true
						break
					end
				end
			end
		end
	elseif Config.Framework == 'QB' then
		if Config.UseNewStaffCheckMethod then 
			for k,v in ipairs(Config.AdminGroups) do
				if QBCore.Functions.HasPermission(source, v) then
					staff = true
					break
				end
			end
		else
			local playerGroup = QBCore.Functions.GetPermission(source)
			
			if Config.QBPermissionsUpdate then
				for group, value in pairs(playerGroup) do
					if value then
						for k,v in ipairs(Config.AdminGroups) do
							if group == v then
								staff = true
								break
							end
						end
					end
				end
			else
				for k,v in ipairs(Config.AdminGroups) do
					if playerGroup == v then
						staff = true
						break
					end
				end
			end
		end
	else
		for i, a in ipairs(Config.StandaloneStaffIdentifiers) do
			for x, b in ipairs(GetPlayerIdentifiers(source)) do
				if string.lower(b) == string.lower(a) then
					staff = true
				end
			end
		end
	end

	return staff
end

function MySQLinsert(query, values, func)
	if Config.Database == 'mysql-async' then
		return MySQL.Async.insert(query, values, func)
	elseif Config.Database == 'oxmysql' then
		return MySQL.insert(query, values, func)
	elseif Config.Database == 'ghmattimysql' then
		return exports.ghmattimysql.execute(query, values, func)
	else
		print("[okokReportsV2] ERROR - no mysql callback! Please set a mysql callback in 'sv_utils.lua'")
	end
end

function getName(source)
	local name = nil
	
	if Config.UseSteamNames then
		name = GetPlayerName(source)
	elseif Config.Framework == 'ESX' then
		local xPlayer = ESX.GetPlayerFromId(source)
		local identifier = xPlayer.identifier
		MySQL.Async.fetchAll('SELECT * FROM users WHERE identifier = @identifier', {
			['@identifier'] = identifier
		}, function(db_name)
			if db_name[1] ~= nil then
				name = db_name[1].firstname.." "..db_name[1].lastname
			else
				name = ""
			end
		end)
		while name == nil do
			Citizen.Wait(2)
		end
	elseif Config.Framework == 'QB' then
		local xPlayer = QBCore.Functions.GetPlayer(source)
		name = xPlayer.PlayerData.charinfo.firstname.." "..xPlayer.PlayerData.charinfo.lastname
	else
		name = GetPlayerName(source)
	end
	return name
end

RegisterServerEvent('okokReportsV2:conclude')
AddEventHandler('okokReportsV2:conclude', function(report_id)
	local _source = source

	if not hasPermission(_source) then return end

	local admin_identifier = reportsList[report_id].admin_identifier

	if admin_identifier ~= nil and Config.SaveRespondedReports then
		MySQLinsert('INSERT INTO okokreports (admin_identifier) VALUES(@admin_identifier) ON DUPLICATE KEY UPDATE admin_identifier=@admin_identifier, responded_reports=responded_reports+1', {
			['@admin_identifier'] = admin_identifier,
		}, function (result)
		end)
	end

	if reportsList[report_id].bringStartPos ~= nil and Config.TeleportBackAfterConcluding then
		local targetPed = GetPlayerPed(tonumber(reportsList[report_id].source))
		SetEntityCoords(targetPed, reportsList[report_id].bringStartPos)
		reportsList[report_id].bringStartPos = nil
	end

	if reportsList[report_id].adminStartPos ~= nil and Config.TeleportBackAfterConcluding then
		local adminPed = GetPlayerPed(_source)
		SetEntityCoords(adminPed, reportsList[report_id].adminStartPos)
		reportsList[report_id].adminStartPos = nil
	end
	TriggerClientEvent('okokReportsV2:Notification', _source, interp(Config.Notifications['adm_rep_concluded'].text, {id = reportsList[report_id].id}), 'adm_rep_concluded')
	TriggerClientEvent('okokReportsV2:Notification', reportsList[report_id].source, interp(Config.Notifications['rep_concluded'].text, {id = reportsList[report_id].id}), 'rep_concluded')

	if adminWebhookLink ~= '' then
		local identifierlist = ExtractIdentifiers(_source)
		local webhookData = {
			color = Config.adminWebhookColor,
			title = Config.ReportTitle,
			action = Config.WebhookMessages['a_closed_report'].action,
			type = interp(Config.WebhookMessages['a_closed_report'].type, {id = reportsList[report_id].id}),
			name = getName(_source),
			title = nil,
			desc = nil,

			playerid = _source,
			identifier = identifierlist.license:gsub("license2:", ""),
			discord = "<@"..identifierlist.discord:gsub("discord:", "")..">",
		}
		discordWebhook(webhookData, adminWebhookLink)
	end
	TriggerEvent('okokReportsV2:OnConcluded', _source, reportsList[report_id].source)
	reportsList[report_id] = nil
end)

-- WEBHOOKS

function discordWebhook(data, url)
	local information = {}
	local description = ''

	if data.title ~= nil or data.desc ~= nil then
		description = '**Action:** '..data.action..'\n**Type:** '..data.type..'\n**Name:** '..data.name..'\n**Title:** '..data.title..'\n**Description:** '..data.desc..'\n\n**ID:** '..data.playerid..'\n**Identifier:** '..data.identifier..'\n**Discord:** '..data.discord
	elseif data.answer ~= nil then
		description = '**Action:** '..data.action..'\n**Type:** '..data.type..'\n**Name:** '..data.name..'\n**Answer:** '..data.answer..'\n\n**ID:** '..data.playerid..'\n**Identifier:** '..data.identifier..'\n**Discord:** '..data.discord
	else
		description = '**Action:** '..data.action..'\n**Type:** '..data.type..'\n**Name:** '..data.name..'\n\n**ID:** '..data.playerid..'\n**Identifier:** '..data.identifier..'\n**Discord:** '..data.discord
	end

	information = {
		{
			["color"] = data.color,
			["author"] = {
				["icon_url"] = Config.IconURL,
				["name"] = Config.ServerName..' - Logs',
			},
			["title"] = Config.ReportTitle,
			["description"] = description,
			["footer"] = {
				["text"] = os.date(Config.DateFormat),
			}
		}
	}
	


	PerformHttpRequest(url, function(err, text, headers) end, 'POST', json.encode({username = Config.BotName, embeds = information}), {['Content-Type'] = 'application/json'})
end

function ExtractIdentifiers(id)
	local identifiers = {
		steam = "",
		ip = "",
		discord = "",
		license = "",
		xbl = "",
		live = ""
	}

	for i = 0, GetNumPlayerIdentifiers(id) - 1 do
		local playerID = GetPlayerIdentifier(id, i)

		if string.find(playerID, "steam") then
			identifiers.steam = playerID
		elseif string.find(playerID, "ip") then
			identifiers.ip = playerID
		elseif string.find(playerID, "discord") then
			identifiers.discord = playerID
		elseif string.find(playerID, "license") then
			identifiers.license = playerID
		elseif string.find(playerID, "xbl") then
			identifiers.xbl = playerID
		elseif string.find(playerID, "live") then
			identifiers.live = playerID
		end
	end

	return identifiers
end